#!/usr/bin/env python

import time
import rtmidi
from rtmidi.midiutil import open_midiport
import socket


# udp send socket
TARGET='127.0.0.1'
UDPPORT=8888

s_udp_sock = socket.socket( socket.AF_INET,  socket.SOCK_DGRAM )


# choose midiport with a menu:
port = None

# open the first Midiport:
#port = "0"


midiin, port_name = open_midiport(port)
print ("%s, %s, %s" % (port_name,TARGET,UDPPORT))


class MidiInputHandler(object):
        def __init__(self, port):
                self.port = port

        def __call__(self, event, data=None):
                message, deltatime = event

                for x in message:
                        r = str(x)
                        s_udp_sock.sendto( r, (TARGET,UDPPORT) )
                        # print bytes to terminal:
                        #print r

midiin.set_callback(MidiInputHandler(port_name))

# enable sysex and midiclock 
midiin.ignore_types(sysex=False, timing=False, active_sense=True)

try:
    # just wait for keyboard interrupt in main thread
    while True:
        time.sleep(1)
except KeyboardInterrupt:
    print('')
finally:
    print("closing %s." % (port_name))
    midiin.close_port()
    del midiin
